import {
  Annotation,
} from '@overflow/commons/core/reflect';

import {
  MetadataKeyType,
  PropertyKeyType,
  TypeUtil,
} from '@overflow/commons/core/type';

import {
  Decorator,
} from '@overflow/commons/decorator';

export interface ActionMappingAnnotationAttributes {
  value: string;
}

export class ActionMappingAnnotation implements Annotation {
  public readonly attributes: ActionMappingAnnotationAttributes;

  public constructor(value: string | ActionMappingAnnotationAttributes) {

    if (undefined === value) {
      throw new Error(`value attribute must be specified.`);
    }

    if (TypeUtil.isString(value)) {
      this.attributes = {
        value: <string>value,
      };
    } else {
      this.attributes = <ActionMappingAnnotationAttributes>value;
    }
  }

  public classDecorator<TFunction extends Function>(target: TFunction): TFunction | void {
    console.log('ActionMapping');
  }

  public methodDecorator<T>(target: Object, propertyKey: PropertyKeyType,
                            descriptor: TypedPropertyDescriptor<T>): TypedPropertyDescriptor<T> | void {
    console.log('ActionMapping');
  }

}

export const ActionMapping = Decorator.create(ActionMappingAnnotation);
