import {
  Annotation,
} from '@overflow/commons/core/reflect';

import {
  MetadataKeyType,
  PropertyKeyType,
  TypeUtil,
} from '@overflow/commons/core/type';

import {
  Decorator,
} from '@overflow/commons/decorator';

export interface RpcAPIAnnotationAttributes {
  method: string;
}

export class RpcAPIAnnotation implements Annotation {
  public readonly attributes: RpcAPIAnnotationAttributes;

  public constructor(method: string | RpcAPIAnnotationAttributes) {
    if (undefined === method) {
      throw new Error(`method attribute must be specified.`);
    }

    if (TypeUtil.isString(method)) {
      this.attributes = {
        method: <string>method,
      };
    } else {
      this.attributes = <RpcAPIAnnotationAttributes>method;
    }
  }

  public methodDecorator<T>(target: Object, propertyKey: PropertyKeyType,
                            descriptor: TypedPropertyDescriptor<T>): TypedPropertyDescriptor<T> | void {
    console.log('RestAPI');
  }
}

export const RpcAPI = Decorator.create(RpcAPIAnnotation);
