
import {
  ClassType,
  Metadata,
  TypeUtil,
} from '@overflow/commons/core/type';
import {
  ActionMappingAnnotation,
  ReducerAnnotation,
  RestAPIAnnotation,
  RpcAPIAnnotation,
} from '@overflow/commons/redux/decorators';
import { Class } from '@overflow/commons/core/reflect';
import { Action } from '@overflow/commons/redux/action';

export default class LPCReducer {

  private reducerMap: Map<string, any[]>;

  protected constructor() {
    this.reducerMap = new Map();
  }

  public reducer<State>(state: State, action: Action): State {
    // let rm: string[] = action.type.split('.');
    // if (null == rm || 2 !== rm.length) {
    //   console.log(`Method[${action.type}] is not valid.`);
    //   return null;
    // }

    // const reducerName: string = rm[0];
    // const methodName: string = rm[1];

    // if (this.reducerMap.has(reducerName)) {
    //   let reducers = this.reducerMap.get(reducerName);
    //   for (let reducer of reducers) {

    //     state = reducer(state, action);
    //   }
    // }

    return state;
  }

  /**
   * registerReducers
   */
  public registerReducers(reducerTypes: ClassType[]): void {
    for (let reducerType of reducerTypes) {
      let clazz: Class = Class.forClass(reducerType);
      let ra: ReducerAnnotation = clazz.getOwnAnnotation(ReducerAnnotation);
      if (undefined === ra) {
        continue;
      }
      console.log(`name: ${ra.attributes.name}`);
      let ama: ActionMappingAnnotation = clazz.getOwnAnnotation(ActionMappingAnnotation);
      if (undefined === ama) {
        continue;
      }
      console.log(`actionMapping-value: ${ama.attributes.value}`);

      clazz.getMethods().forEach(method => {
        let restAPIAnnotation: RestAPIAnnotation = method.getOwnAnnotation(RestAPIAnnotation);
        let rpcAPIAnnotation: RpcAPIAnnotation = method.getOwnAnnotation(RpcAPIAnnotation);
        if (restAPIAnnotation) {
          console.log(`restAPI: ${restAPIAnnotation.attributes.entryPath}`);
        }
        if (rpcAPIAnnotation) {
          console.log(`restAPI: ${rpcAPIAnnotation.attributes.method}`);
        }
      });

    }

  }

  /**
   * registerReducer
   */
  public registerReducer(reducerType: ClassType): void {
    console.log(``);

  }
}
